Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## com.fasterxml.jackson.databind.deser
Class ValueInstantiator

    java.lang.Object
      com.fasterxml.jackson.databind.deser.ValueInstantiator

Direct Known Subclasses:
  JacksonDeserializers.JsonLocationInstantiator, StdValueInstantiator

    public abstract class ValueInstantiator

extends Object

Class that defines simple API implemented by objects that create value instances. Some or all of properties of value instances may be initialized by instantiator, rest being populated by deserializer, to which value instance is passed. Since different kinds of JSON values (structured and scalar) may be bound to Java values, in some cases instantiator fully defines resulting value; this is the case when JSON value is a scalar value (String, number, boolean).

Note that this type is not parameterized (even though it would seemingly make sense), because such type information can not be use effectively during runtime: access is always using either wildcard type, or just basic `Object`; and so adding type parameter seems like unnecessary extra work.

Actual implementations are strongly recommended to be based on `StdValueInstantiator` which implements all methods, and as such will be compatible across versions even if new methods were added to this interface.

Constructor Summary
`ValueInstantiator()`

Method Summary
`boolean` | `canCreateFromBoolean()` Method that can be called to check whether a double (boolean / Boolean) based creator is available to use (to call `createFromDouble(com.fasterxml.jackson.databind.DeserializationContext, double)`).
`boolean` | `canCreateFromDouble()` Method that can be called to check whether a double (double / Double) based creator is available to use (to call `createFromDouble(com.fasterxml.jackson.databind.DeserializationContext, double)`).
`boolean` | `canCreateFromInt()` Method that can be called to check whether an integer (int, Integer) based creator is available to use (to call `createFromInt(com.fasterxml.jackson.databind.DeserializationContext, int)`).
`boolean` | `canCreateFromLong()` Method that can be called to check whether a long (long, Long) based creator is available to use (to call `createFromLong(com.fasterxml.jackson.databind.DeserializationContext, long)`).
`boolean` | `canCreateFromObjectWith()` Method that can be called to check whether a property-based creator (argument-taking constructor or factory method) is available to instantiate values from JSON Object
`boolean` | `canCreateFromString()` Method that can be called to check whether a String-based creator is available for this instantiator
`boolean` | `canCreateUsingDefault()` Method that can be called to check whether a default creator (constructor, or no-arg static factory method) is available for this instantiator
`boolean` | `canCreateUsingDelegate()` Method that can be called to check whether a delegate-based creator (single-arg constructor or factory method) is available for this instantiator
`boolean` | `canInstantiate()` Method that will return true if any of `canCreateXxx` method returns true: that is, if there is any way that an instance could be created.
`Object` | `createFromBoolean(DeserializationContext ctxt, boolean value)`
`Object` | `createFromDouble(DeserializationContext ctxt, double value)`
`Object` | `createFromInt(DeserializationContext ctxt, int value)`
`Object` | `createFromLong(DeserializationContext ctxt, long value)`
`Object` | `createFromObjectWith(DeserializationContext ctxt, Object[] args)` Method called to create value instance from JSON Object when instantiation arguments are passed; this is done, for example when passing information specified with "Creator" annotations.
`Object` | `createFromString(DeserializationContext ctxt, String value)`
`Object` | `createUsingDefault(DeserializationContext ctxt)` Method called to create value instance from a JSON value when no data needs to passed to creator (constructor, factory method); typically this will call the default constructor of the value object.
`Object` | `createUsingDelegate(DeserializationContext ctxt, Object delegate)` Method to called to create value instance from JSON Object using an intermediate "delegate" value to pass to createor method
`AnnotatedWithParams` | `getDefaultCreator()` Method that can be called to try to access member (constructor, static factory method) that is used as the "default creator" (creator that is called without arguments; typically default [zero-argument] constructor of the type).
`AnnotatedWithParams` | `getDelegateCreator()` Method that can be called to try to access member (constructor, static factory method) that is used as the "delegate creator".
`JavaType` | `getDelegateType(DeserializationConfig config)` Method that can be used to determine what is the type of delegate type to use, if any; if no delegates are used, will return null.
`SettableBeanProperty[]` | `getFromObjectArguments(DeserializationConfig config)` Method called to determine types of instantiation arguments to use when creating instances with creator arguments (when `canCreateFromObjectWith()` returns true).
`abstract String` | `getValueTypeDesc()` Method that returns description of the value type this instantiator handles.
`AnnotatedWithParams` | `getWithArgsCreator()` Method that can be called to try to access member (constructor, static factory method) that is used as the "non-default creator" (constructor or factory method that takes one or more arguments).

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### ValueInstantiator

    public ValueInstantiator()

Method Detail

### getValueTypeDesc

    public abstract String getValueTypeDesc()

  Method that returns description of the value type this instantiator handles. Used for error messages, diagnostics.

### canInstantiate

    public boolean canInstantiate()

  Method that will return true if any of `canCreateXxx` method returns true: that is, if there is any way that an instance could be created.

### canCreateFromString

    public boolean canCreateFromString()

  Method that can be called to check whether a String-based creator is available for this instantiator

### canCreateFromInt

    public boolean canCreateFromInt()

  Method that can be called to check whether an integer (int, Integer) based creator is available to use (to call `createFromInt(com.fasterxml.jackson.databind.DeserializationContext, int)`).

### canCreateFromLong

    public boolean canCreateFromLong()

  Method that can be called to check whether a long (long, Long) based creator is available to use (to call `createFromLong(com.fasterxml.jackson.databind.DeserializationContext, long)`).

### canCreateFromDouble

    public boolean canCreateFromDouble()

  Method that can be called to check whether a double (double / Double) based creator is available to use (to call `createFromDouble(com.fasterxml.jackson.databind.DeserializationContext, double)`).

### canCreateFromBoolean

    public boolean canCreateFromBoolean()

  Method that can be called to check whether a double (boolean / Boolean) based creator is available to use (to call `createFromDouble(com.fasterxml.jackson.databind.DeserializationContext, double)`).

### canCreateUsingDefault

    public boolean canCreateUsingDefault()

  Method that can be called to check whether a default creator (constructor, or no-arg static factory method) is available for this instantiator

### canCreateUsingDelegate

    public boolean canCreateUsingDelegate()

  Method that can be called to check whether a delegate-based creator (single-arg constructor or factory method) is available for this instantiator

### canCreateFromObjectWith

    public boolean canCreateFromObjectWith()

  Method that can be called to check whether a property-based creator (argument-taking constructor or factory method) is available to instantiate values from JSON Object

### getFromObjectArguments

    public SettableBeanProperty[] getFromObjectArguments(DeserializationConfig config)

  Method called to determine types of instantiation arguments to use when creating instances with creator arguments (when `canCreateFromObjectWith()` returns true). These arguments are bound from JSON, using specified property types to locate deserializers.

  NOTE: all properties will be of type `CreatorProperty`.

### getDelegateType

    public JavaType getDelegateType(DeserializationConfig config)

  Method that can be used to determine what is the type of delegate type to use, if any; if no delegates are used, will return null. If non-null type is returned, deserializer will bind JSON into specified type (using standard deserializer for that type), and pass that to instantiator.

### createUsingDefault

    public Object createUsingDefault(DeserializationContext ctxt)
                              throws IOException,
                                     JsonProcessingException

  Method called to create value instance from a JSON value when no data needs to passed to creator (constructor, factory method); typically this will call the default constructor of the value object. It will only be used if more specific creator methods are not applicable; hence "default".

  This method is called if `getFromObjectArguments(com.fasterxml.jackson.databind.DeserializationConfig)` returns null or empty List.

  Throws:
    `IOException`
    `JsonProcessingException`

### createFromObjectWith

    public Object createFromObjectWith(DeserializationContext ctxt,
                                       Object[] args)
                                throws IOException,
                                       JsonProcessingException

  Method called to create value instance from JSON Object when instantiation arguments are passed; this is done, for example when passing information specified with "Creator" annotations.

  This method is called if `getFromObjectArguments(com.fasterxml.jackson.databind.DeserializationConfig)` returns a non-empty List of arguments.

  Throws:
    `IOException`
    `JsonProcessingException`

### createUsingDelegate

    public Object createUsingDelegate(DeserializationContext ctxt,
                                      Object delegate)
                               throws IOException,
                                      JsonProcessingException

  Method to called to create value instance from JSON Object using an intermediate "delegate" value to pass to createor method

  Throws:
    `IOException`
    `JsonProcessingException`

### createFromString

    public Object createFromString(DeserializationContext ctxt,
                                   String value)
                            throws IOException,
                                   JsonProcessingException

  Throws:
    `IOException`
    `JsonProcessingException`

### createFromInt

    public Object createFromInt(DeserializationContext ctxt,
                                int value)
                         throws IOException,
                                JsonProcessingException

  Throws:
    `IOException`
    `JsonProcessingException`

### createFromLong

    public Object createFromLong(DeserializationContext ctxt,
                                 long value)
                          throws IOException,
                                 JsonProcessingException

  Throws:
    `IOException`
    `JsonProcessingException`

### createFromDouble

    public Object createFromDouble(DeserializationContext ctxt,
                                   double value)
                            throws IOException,
                                   JsonProcessingException

  Throws:
    `IOException`
    `JsonProcessingException`

### createFromBoolean

    public Object createFromBoolean(DeserializationContext ctxt,
                                    boolean value)
                             throws IOException,
                                    JsonProcessingException

  Throws:
    `IOException`
    `JsonProcessingException`

### getDefaultCreator

    public AnnotatedWithParams getDefaultCreator()

  Method that can be called to try to access member (constructor, static factory method) that is used as the "default creator" (creator that is called without arguments; typically default [zero-argument] constructor of the type). Note that implementations not required to return actual object they use (or, they may use some other instantiation) method. That is, even if `canCreateUsingDefault()` returns true, this method may return null .

### getDelegateCreator

    public AnnotatedWithParams getDelegateCreator()

  Method that can be called to try to access member (constructor, static factory method) that is used as the "delegate creator". Note that implementations not required to return actual object they use (or, they may use some other instantiation) method. That is, even if `canCreateUsingDelegate()` returns true, this method may return null .

### getWithArgsCreator

    public AnnotatedWithParams getWithArgsCreator()

  Method that can be called to try to access member (constructor, static factory method) that is used as the "non-default creator" (constructor or factory method that takes one or more arguments). Note that implementations not required to return actual object they use (or, they may use some other instantiation) method. That is, even if `canCreateFromObjectWith()` returns true, this method may return null .

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2012 FasterXML. All Rights Reserved.